motion_rules :: Rule ()
motion_rules = do
  forall location <- all_locations do
   auto_switch_off(location)
   observe_motion_detector(location)
   if location_is_room(location) then
     auto_switch_on_in_room(location)
    else 
     auto_switch_on_in_hallway(location)


control_system_alive :: Rule ()
control_system_alive =
   forall location <- all_locations do
    forall light <- lights_at(location) do
     send_to((location, light), ControlSystemIsAlive)

light_rules = do
   forall room <- all_rooms do use_daylight(room)
   energieH := take maxHistory (power_consumption : energieH)


malfunction_of_light :: (Location, Light) -> Bool
malfunction_of_light(location, light) =
   status_of_light(location, light) /= status_line(location, light)

