status_of_light :: AsmVar ((Location, Light) -> LightStatus)
status_of_light = initAssocs "status_of_light"
                    [ ((loc, l), Light_Off)
                    | loc <- all_locations, l   <- Tasklight : lights_at(loc)
                    ]

current_time :: AsmVar Time
current_time = initVal "current_time" 0.0


last_light_scene :: AsmVar (Room -> Scene)
last_light_scene = initAssocs "last_light_scene"
                    [ (room, default_light_scene(room))
                    | room  <- all_rooms
                    ]

dim_value :: AsmVar ((Location, Light) -> DimValue)
dim_value = initAssocs "dim_value"
                  [ ((location, light), minDimValue)
                  | location  <- all_locations, light <- lights_at(location)
                  ]

last_motion :: AsmVar (Location -> Time)
last_motion = initAssocs "last_motion" 
      ([ (hw, -(maximum [max_quiet_time, t2(hw)] + 1.0))
       | hw <- all_hallways
       ] ++
       [ (room, -(maximum [max_quiet_time, t1(room), t3(room)] + 1.0))
       | room <- all_rooms
       ])

dim_value_history :: AsmVar ((Room, Light, Time) -> DimValue)
dim_value_history = initAssocs "dim_value_history"
                    [ ((room, light, current_time), minDimValue)
                    | room  <- all_rooms, light <- lights_at(room)
                    ]

facility_manager :: AsmVar ((Malfunction, Time) -> Bool)
facility_manager = initAssocs "facility_manager" []

user_information :: AsmVar ((Room, Time, Malfunction) -> Bool)
user_information = initAssocs "user_information" []

database :: AsmVar ((Time, Malfunction) -> Bool)
database = initAssocs "database" []

mode :: AsmVar (Room -> Mode)
mode = initAssocs "mode" [ (r,Manual) | r <- all_rooms ]


