lights_at :: Location -> [Light]
lights_at (loc) | location_is_room(loc)
                  = lights_in_group(loc, LightGroupWindow) ++
                    lights_in_group(loc, LightGroupWall)
                | otherwise 
                  = lights_in_hallway(loc)


default_light_scene :: Room -> Scene
default_light_scene (room) = S [(lights, 100)]
    where lights = [ l | l@(Light(_)) <- lights_at(room) ]

all_components :: [Component]
all_components = 
     [ OutdoorLightSensor(1), OutdoorLightSensor(2) ] 
  ++ [ MotionSensor(loc, 0) | loc <- all_locations  ]
  ++ [ HallwayButton(hw,0)  | hw  <- all_hallways   ]
  ++ [ Luminaire(loc, light)
     | loc   <- all_locations
     , light <- if location_is_room(loc)
                 then Tasklight : lights_at(loc)
                 else lights_at(loc)
     ]

