














-- 
-- \begin{asm}
           
data Motion = MDefect | MAlways | MMotion Time | MNoMotion

type Time         = Float
type DimValue     = Int
type Lux          = Int
type LightSensor  = Int
type MotionSensor = Int
-- \end{asm}
-- 
-- \begin{asm}
           
data Location = Room(Int)
              | Hallway(Int) 

type Room    = Location
type Hallway = Location
-- \end{asm}
-- 
-- \begin{asm}
           
data Light = Light(Int) | Tasklight

data LightStatus = Light_On | Light_Off
-- \end{asm}
-- 
-- \begin{asm}
           
data Component   = OutdoorLightSensor(Int)
                 | MotionSensor(Location, Int)
                 | HallwayButton(Hallway, Int)
                 | Luminaire(Location, Light) 
-- \end{asm}
-- 
-- \begin{asm}
           
data LightGroup = LightGroupWindow
                | LightGroupWall 
-- \end{asm}
-- 
-- \begin{asm}
           
data Mode = Manual
          | Ambient 

data Event = ControlSystemIsAlive
-- \end{asm}
-- 
-- \begin{asm}
           
data Malfunction = LightDefect(Location, Light)
                 | LightSensorDefect(LightSensor)
                 | MotionSensorDefect(Room, MotionSensor)
                 | HallwayButtonDefect(Hallway, Int) 
-- \end{asm}
-- 
-- 
-- 
-- \begin{asm}
           
data PanelSwitch = LightGroup(LightGroup)
                 | TaskLight
                 | SceneSelection
                 | AmbientSelection 
-- \end{asm}
-- 
-- \begin{asm}
           
data Scene = S [([Light], DimValue)]

data SwitchValue = On
                 | Off
                 | Scene Scene 
-- \end{asm}
-- 
